The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Blit Class Reference

STK band-limited impulse train class. More...

`#include <Blit.h>`

Inheritance diagram for stk::Blit:

## Public Member Functions
| Blit (StkFloat frequency=220.0)
| Default constructor that initializes BLIT frequency to 220 Hz.
| ~Blit ()
| Class destructor.
void | reset ()
| Resets the oscillator state and phase to 0.
void | setPhase (StkFloat phase)
| Set the phase of the signal.
StkFloat | getPhase () const
| Get the current phase of the signal.
void | setFrequency (StkFloat frequency)
| Set the impulse train rate in terms of a frequency in Hz.
void | setHarmonics (unsigned int nHarmonics=0)
| Set the number of harmonics generated in the signal.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK band-limited impulse train class.

This class generates a band-limited impulse train using a closed-form algorithm reported by Stilson and Smith in "Alias-Free Digital Synthesis of Classic Analog Waveforms", 1996. The user can specify both the fundamental frequency of the impulse train and the number of harmonics contained in the resulting signal.

The signal is normalized so that the peak value is +/-1.0.

If nHarmonics is 0, then the signal will contain all harmonics up to half the sample rate. Note, however, that this setting may produce aliasing in the signal when the frequency is changing (no automatic modification of the number of harmonics is performed by the setFrequency() function).

Original code by Robin Davies, 2005. Revisions by Gary Scavone for STK, 2005.

## Member Function Documentation

## ◆ setPhase()

void stk::Blit::setPhase | ( | StkFloat | phase | ) |
| inline

Set the phase of the signal.

Set the phase of the signal, in the range 0 to 1.

49{ phase_ = PI * phase; };

## ◆ getPhase()

StkFloat stk::Blit::getPhase | ( |  | ) | const
| inline

Get the current phase of the signal.

Get the phase of the signal, in the range [0 to 1.0).

55{ return phase_ / PI; };

## ◆ setHarmonics()

void stk::Blit::setHarmonics | ( | unsigned int | nHarmonics = `0` | ) |

Set the number of harmonics generated in the signal.

This function sets the number of harmonics contained in the resulting signal. It is equivalent to (2 * M) + 1 in the BLIT algorithm. The default value of 0 sets the algorithm for maximum harmonic content (harmonics up to half the sample rate). This parameter is not checked against the current sample rate and fundamental frequency. Thus, aliasing can result if one or more harmonics for a given fundamental frequency exceeds fs / 2. This behavior was chosen over the potentially more problematic solution of automatically modifying the M parameter, which can produce audible clicks in the signal.

## ◆ tick()

StkFrames & stk::Blit::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

133{
134#if defined(_STK_DEBUG_)
135 if ( channel >= frames.channels() ) {
136 oStream_ << "Blit::tick(): channel and StkFrames arguments are incompatible!";
137 handleError( StkError::FUNCTION_ARGUMENT );
138 }
139#endif
140
141 StkFloat *samples = &frames[channel];
142 unsigned int hop = frames.channels();
143 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
144 *samples = Blit::tick();
145
146 return frames;
147}
stk::Blit::tick
StkFloat tick(void)
Compute and return one output sample.
Definition Blit.h:103
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- Blit.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.